【从零开始的LeetCode-算法】3191. 使二进制数组全部等于 1 的最少操作次数 I

给你一个二进制数组 nums 。

你可以对数组执行以下操作 任意 次(也可以 0 次):

  • 选择数组中 任意连续 3 个元素,并将它们 全部反转 。

反转 一个元素指的是将它的值从 0 变 1 ,或者从 1 变 0 。

请你返回将 nums 中所有元素变为 1 的 最少 操作次数。如果无法全部变成 1 ,返回 -1 。

示例 1:

**输入:**nums = 0,1,1,1,0,0

**输出:**3

解释:

我们可以执行以下操作:

  • 选择下标为 0 ,1 和 2 的元素并反转,得到 nums = [++1++ ,++0++ ,++0++,1,0,0] 。
  • 选择下标为 1 ,2 和 3 的元素并反转,得到 nums = [1,++1++ ,++1++ ,++0++,0,0] 。
  • 选择下标为 3 ,4 和 5 的元素并反转,得到 nums = [1,1,1,++1++ ,++1++ ,++1++] 。

示例 2:

**输入:**nums = 0,1,1,1

输出:-1

解释:

无法将所有元素都变为 1 。

提示:

  • 3 <= nums.length <= 105
  • 0 <= nums[i] <= 1

我的解答:

java 复制代码
class Solution {
    public int minOperations(int[] nums) {
        int size = nums.length;
        int res = 0;
        // 遍历除倒数最后两个以外的所有元素,因为最后两个元素不能单独反转
        for(int i = 0; i < size - 2; i++){
            // 如果当前索引元素为0,则该索引及后面两个元素都进行异或运算
            if(nums[i] == 0){
                nums[i] ^= 1;
                nums[i + 1] ^= 1;
                nums[i + 2] ^= 1;
                res++;
            }
        } 
        // 判断倒数最后两个元素是否都为1,是则返回操作次数,否则返回-1
        return nums[size - 1] + nums[size - 2] == 2 ? res : -1;
    }
}
相关推荐
念何架构之路27 分钟前
zap采样器与性能优化内幕
算法·性能优化·哈希算法
泡茶喝茶写代码1 小时前
A股量化数据工程:从 REST 接口到策略信号(第 8 篇):成长能力因子:营收与利润增速
java·python·股票数据api·股票数据api接口·股票量化数据api·股票量化数据接口·股票数据api数据
晒太羊的猫1 小时前
hot100动态规划刷题
算法·动态规划
\光辉岁月/2 小时前
7.javase-面向对象
java·开发语言
weixin_531094692 小时前
heap_4内存管理
java·开发语言·算法
余额瞒着我当琳2 小时前
红黑树的实现--红黑树的概念、规则、效率、结构、旋转、查找、验证
数据结构·c++·算法
程序员南飞2 小时前
win系统安装minio
java·数据结构·算法
青少儿编程课堂2 小时前
AC自动机多模式串匹配精讲:校园关键词巡检实战解析
c++·python·算法·bfs·信息学竞赛
Escalating_xu2 小时前
【Python】使用库:标准库、第三方库、pip、项目实战与程序打包
java·python·pip
longlongzihan3 小时前
LeetCode 5. 最长回文子串:从暴力匹配到中心扩展的思维演进
c++·算法·leetcode